;mt100_lo ?
	device zxspectrum128
        ORG #6000
begin


;+0
bcd_cnt:			; counter used for print_mp
	db	0, 0		; 0-1
beg_ptr:			; 16-bits used to store pointers to arrays
cur_ptr:			; 16-bits used to store pointers to arrays
;+2
	db	0, 0		; 2-3
end_ptr:			; 16-bits used to store pointers to arrays
;+4
	db	0, 0		; 4-5
;+6
n:	db	0, 0		; 6-7, used by atan_mp
divisor:			; divisor for div_mp and div16_mp
;+8
	db	0, 0		; 8-9
;+10
	db	0		; A (place holder)
;+11
regx:	db	0		; B, the x in atan(1/x)
;+12
x2:	db	0		; C, cached x*x
;+13
ptr_a:	db	0, 0		; D-E, pointer to array used by atan_mp
;+15
	db	0		; F (place holder)
				; table of squares
sqrtbl:	db	0, 1, 4, 9, 16, 25, 36, 49, 64, 81, 100
	db	121, 144, 169, 196, 225
pitext:	db	"1000 DIGITS OF PI = ",0

runi:
; 
  LD            HL ,$5CB6
  LD            ($5C4F),HL
  LD            DE ,$15AF
  LD            BC ,$0015
  EX            DE ,HL
  LDIR
  EX            DE ,HL
  DEC           HL
  LD            ($5C57),HL
  INC           HL
  LD            ($5C53),HL
  LD            ($5C4B),HL
  LD            (HL)  ,$80
  INC           HL
  LD            ($5C59),HL;E-LINE

;2
 ld hl,$15C6
 ld de,$5C10
 ld bc,$0E
 ldir

; 
 ld a,2
 call $1601

	ld a,22
	rst 10h

	ld a,0
	rst 10h

	ld a,0
	rst 10h
;********************************************************************
dec_len	=	1000		; 1000 decimal digits
bcd_len	=	65536-(dec_len/2)

bin_len	=	418		; ceil(1001 / log(256)) + 1 (+ 1 if odd) = 418
				;   Duff's Device 4x unrolled loops assume
				;   bin_len % 4 = 2
bin_end =	bin_len-1

unrollc	=	(bin_len/4)+1	; the number of 4x unrolled loop is 
mp_a=$8000+9*256+76
mp_b=$8000+10*256+240
mp_x=$8000+148+12*256
mp_y=$8000+56+14*256

 macro dch
 dec h
 endm
 
 ld sp,$5FE0
;	ldhli	pitext		; load pitext address
;L64:	ld l,32;LLI 54 32
;L66:	ld h,0;LHI 46 0
	ld hl,pitext
;L68:	call L119;CAL70 119 0
	call	print		;+ print pitext message

;	jr $
;L71:	call L196;CAL70 196 0
;	cal	pi		; compute Pi and store in mp_a
	call pi

;	mprint	mp_a		; print Pi
;mprint	macro	a		; print (a) base 100
;	ldhli	a		; HL <- ptr
;	cal	print_mp
;	endm
;L74:	ld l,76;LLI 54 76
;L76:	ld h,9;LHI 46 9
	ei
	ld hl,mp_a
	call print_mp;L2190;CAL70 142 8
	jr $
;L81:	rst070;RST070 61
;L82:	rst070;RST070 61
;L83:	halt;HLT 0

prbcd:
;L84:
	ld b,a;LBA 200
	rrca;rrc;RRC 10; Rotate A Right, bit 0 to Carry
	rrca;rrc;RRC 10
	rrca;rrc;RRC 10
	rrca;rrc;RRC 10
	call L93;CAL70 93 0
	ld a,b;LAB 193

L93:
	and 15;NDI 36 15
	or 48;ORI 52 48
	push bc
	rst 10h;out12;OUT014 89
	pop bc
	ret;RET 7

;L99:
; Description:  Convert BIN/HEX to BCD.
; Input:        A = BIN/HEX (00h - 63h)

; Output:       A = BCD (00 - 99)
; Registers:    A, B, C

bintobcd:

	ld b,a;LBA 200
; start counter at -1
	ld c,255;LCI 22 255
L102:
	inc c;INC 16
; A=A-10
	sub 10;SUI 20 10
;	jfs	-		; loop if positive
	jp p,L102;jfs L102;JFS80 102 0
;	lab			; A <- B, restore A
	ld a,b;LAB 193
;	jmp	++		; jump to dcc
	jp L114;JMP68 114 0
L112:
;/	adi	6		; A=A+6
	add 6;ADI 4 6
L114:
;/	dcc			; if a < 10, then c will be -1 and end loop
	dec c;DCC 17
	jp p,L112;jfs L112;JFS80 112 0
	ret;RET 7

print:
	ld a,(hl);LAM 199
	and a;NDA 160
	ret z;RTZ 43
	rst 10h;out12;OUT014 89
	inc l;INL 48
	jp nz,print;L119;JFZ72 119 0
	inc h;INH 40
	jp print;L119;JMP68 119 0

; Description:  Set mp array initial value:  a = b
;
; Input:        H/L (hi/lo) address to array (a)
;               B = value left of decimal
;
; Output:       a[0] = B
;               a[1] - a[length-1] = 0
;
; Registers:    A, B, E, H, L

set_mp:
	ld (hl),b;LMB 249
;	ldi	unrollc		; count down to 0
	ld d,unrollc;105;LDI 30 105
	xor a;XRA 168

;	jmp	++		; Duff's Device hardcoded for fixed array length
;				;   bin_len % 4 = 2
;L135:
	jp L148;JMP68 148 0

L138:
	inc l;INL 48
	ld (hl),a;LMA 248
	inc l;INL 48
	ld (hl),a;LMA 248

;L142:	inc l;INL 48
;L143:	jp nz,L147;JFZ72 147 0
;L146:	inc h;INH 40
	inc hl
	ld (hl),a;LMA 248

L148:
	inc l;INL 48

	ld (hl),a;LMA 248
	dec d;DCD 25
	jp nz,L138;JFZ72 138 0
	ret;RET 7

; Description:  Multiprecision left shift:  a = a * 2
; Input:        H/L (hi/lo) address to array (a)
; Output:       a = a * 2
; Registers:    A, D, E, H, L

asl_mp:
				; compute end of array since we have
				;   to go backwards
;L155:
	ld a,l;LAL 198
;L156:	add a,162;ADI 4 162
;	adi	lo(bin_len)	; add bin_len lo and store it
	add bin_len&255
	ld l,a;LLA 240

	ld a,h;LAH 197
;L160:	adc a,1;ACI 12 1
;	aci	hi(bin_len)	; add with carry ben_len hi and store it
	adc bin_len/256
	ld h,a;LHA 232

;	ld d,105;LDI 30 105
;	ldi	unrollc		; count down to 0
	ld d,unrollc
	
	or a;ORA 176; clear carry

;	jmp	++		; Duff's Device hardcoded for fixed array length
	jp L183;JMP68 183 0

L169:
;/	dchl			; HL--
;L169:	inc l;INL 48
;L170:	dec l;DCL 49
;L171:	jp nz,L175;JFZ72 175 0
;L174:	dch;DCH 41
;L175:	dec l;DCL 49
	dec hl

	ld a,(hl);LAM 199
	rl a;RAL 18
	ld (hl),a;LMA 248
	dec l;DCL 49
	ld a,(hl);LAM 199
	rl a;RAL 18
	ld (hl),a;LMA 248
L183 ;??????????????????????????
	dec l;DCL 49
	ld a,(hl);LAM 199
	rl a;RAL 18
	ld (hl),a;LMA 248
	dec l;DCL 49
	ld a,(hl);LAM 199
	rl a;RAL 18
	ld (hl),a;LMA 248
	dec d;DCD 25
	jp nz,L169;JFZ72 169 0
	ret;RET 7

; Description:  Compute pi using the Gregory expansion of Machin's arctan
;               formula and save in array mp_a.
;
;   pi = 4 * (4 *      atan(1/5)           -           atan(1/239)          )
;
;
;   __      /   / 1     1      1       \       / 1       1        1        \\
;   || = 4 | 4 |  - - ---- + ---- - ... |  -  | --- - ------ + ------ - ... ||
;          |   |  5      3      5       |     | 239        3        5       ||
;           \   \     3x5    5x5       /       \      3x239    5x239       //
;
;
; Input:        None
; Output:       mp_a = pi = 4 * (4 * atan(1/5) - atan(1/239))
; Registers:    A, B, C, D, E, H, L
; Calls:        matan/atan_mp, masl/asl_mp, msub/sub_mp
pi:
;L196:
;matan	mp_a,5		; a = atan(1/5)
;matan	macro	a, b		; a = atan(1/b)
;	ldhli	a
;	lbi	b
;	cal	atan_mp
;	endm

;	ld l,76;LLI 54 76
;L198:	ld h,9;LHI 46 9
	ld hl,mp_a
L200:	ld b,5;LBI 14 5
L202:	call atan_mp;L768;CAL70 0 3

;	masl	mp_a		; a = a * 4
;masl	macro	a		; a = a * 2
;	ldhli	a
;	cal	asl_mp
;	endm
;L205:	ld l,76;LLI 54 76
;L207:	ld h,9;LHI 46 9
	ld hl,mp_a
	call asl_mp;+L155;CAL70 155 0

;	masl	mp_a
;L212:	ld l,76;LLI 54 76
;L214:	ld h,9;LHI 46 9
	ld hl,mp_a
	call asl_mp;+L155;CAL70 155 0

;	matan	mp_b,239	; b = atan(1/239)
;L219:	ld l,240;LLI 54 240
;L221:	ld h,10;LHI 46 10
	ld hl,mp_b
	ld b,239;LBI 14 239
	call atan_mp;L768;CAL70 0 3

;	msub	mp_a,mp_b	; a = a - b
;msub	macro	a, b		; a = a - b
;	ldhli	a
;	ldbci	b
;	cal	sub_mp
;	endm
;L228:	ld l,76;LLI 54 76
;L230:	ld h,9;LHI 46 9
	ld hl,mp_a

;L232:	ld c,240;LCI 22 240
;L234:	ld b,10;LBI 14 10
	ld bc,mp_b

L236:	call sub_mp;+L1155;CAL70 131 4

;	masl	mp_a		; a = a * 4
;L239:	ld l,76;LLI 54 76
;L241:	ld h,9;LHI 46 9
	ld hl,mp_a
	call asl_mp;+L155;CAL70 155 0

;	masl	mp_a
;L246:	ld l,76;LLI 54 76
;L248:	ld h,9;LHI 46 9
	ld hl,mp_a
	call asl_mp;+L155;CAL70 155 0

L253:	ret;RET 7

;L254:	halt;HLT 0
;L255:	halt;HLT 0
;L256:	halt;HLT 0
;L257:	jp L11464;JMP100 200 44
;L260:	sub a,a;SUA 144
;L261:	ld l,e;LLE 244
;L262:	jfp L8380;JFP88 188 32
;L265:	add a,e;ADE 132
;L266:	ld h,a;LHA 232
;L267:	jp L5296;JMP76 176 20
;L270:	jtpL16604;JTP120 220 64
;L273:	and e;NDE 164
;L274:	inc b;INB 8
;L275:	jpL13520;JMP108 208 52
;L278:	sbc a,a;SBA 152
;L279:	ld (hl),e;LME 252
;L280:	jp c,L10436;JTC96 196 40
;L283:	adc a,e;ACE 140
;L284:	ld l,a;LLA 240
;L285:	jp L7352;JMP84 184 28
;L288:	add a,a;ADA 128
;L289:	ld e,e;LEE 228
;L290:	jp nz,L4268;JFZ72 172 16
;L293:	jp L15576;JMP116 216 60
;L296:	and a;NDA 160
;L297:	add a,104;ADI 4 104
;L299:	ld b,e;LBE 204
;L300:	inc l;INL 48
;L301:	sub a,e;SUE 148
;L302:	ld (hl),a;LMA 248
;L303:	jp L9408;JMP92 192 36
;L306:	adc a,a;ACA 136
;L307:	ld h,e;LHE 236
;L308:	jfs L6324;JFS80 180 24
;L311:	jp L17632;JMP124 224 68
;L314:	xor a;XRA 168
;L315:	adc a,112;ACI 12 112
;L317:	ld c,e;LCE 212
;L318:	nop;NOP 56
;L319:	sbc a,e;SBE 156
;L320:	halt;HLT 0
;L321:	jp L11464;JMP100 200 44
;L324:	sub a,a;SUA 144
;L325:	ld l,e;LLE 244
;L326:	jfp L8380;JFP88 188 32
;L329:	add a,e;ADE 132
;L330:	ld h,a;LHA 232
;L331:	jp L5296;JMP76 176 20
;L334:	jtpL16604;JTP120 220 64
;L337:	and e;NDE 164
;L338:	inc b;INB 8
;L339:	jpL13520;JMP108 208 52
;L342:	sbc a,a;SBA 152
;L343:	ld (hl),e;LME 252
;L344:	jp c,L10436;JTC96 196 40
;L347:	adc a,e;ACE 140
;L348:	ld l,a;LLA 240
;L349:	jp L7352;JMP84 184 28
;L352:	add a,a;ADA 128
;L353:	ld e,e;LEE 228
;L354:	jp nz,L4268;JFZ72 172 16
;L357:	jp L15576;JMP116 216 60
;L360:	and a;NDA 160
;L361:	add a,104;ADI 4 104
;L363:	ld b,e;LBE 204
;L364:	inc l;INL 48
;L365:	sub a,e;SUE 148
;L366:	ld (hl),a;LMA 248
;L367:	jp L9408;JMP92 192 36
;L370:	adc a,a;ACA 136
;L371:	ld h,e;LHE 236
;L372:	jfs L6324;JFS80 180 24
;L375:	jp L17632;JMP124 224 68
;L378:	xor a;XRA 168
;L379:	adc a,112;ACI 12 112
;L381:	ld c,e;LCE 212
;L382:	nop;NOP 56
;L383:	sbc a,e;SBE 156
;L384:	halt;HLT 0
;L385:	jp L11464;JMP100 200 44
;L388:	sub a,a;SUA 144
;L389:	ld l,e;LLE 244
;L390:	jfp L8380;JFP88 188 32
;L393:	add a,e;ADE 132
;L394:	ld h,a;LHA 232
;L395:	jp L5296;JMP76 176 20
;L398:	jtpL16604;JTP120 220 64
;L401:	and e;NDE 164
;L402:	inc b;INB 8
;L403:	jpL13520;JMP108 208 52
;L406:	sbc a,a;SBA 152
;L407:	ld (hl),e;LME 252
;L408:	jp c,L10436;JTC96 196 40
;L411:	adc a,e;ACE 140
;L412:	ld l,a;LLA 240
;L413:	jp L7352;JMP84 184 28
;L416:	add a,a;ADA 128
;L417:	ld e,e;LEE 228
;L418:	jp nz,L4268;JFZ72 172 16
;L421:	jp L15576;JMP116 216 60
;L424:	and a;NDA 160
;L425:	add a,104;ADI 4 104
;L427:	ld b,e;LBE 204
;L428:	inc l;INL 48
;L429:	sub a,e;SUE 148
;L430:	ld (hl),a;LMA 248
;L431:	jp L9408;JMP92 192 36
;L434:	adc a,a;ACA 136
;L435:	ld h,e;LHE 236
;L436:	jfs L6324;JFS80 180 24
;L439:	jp L17632;JMP124 224 68
;L442:	xor a;XRA 168
;L443:	adc a,112;ACI 12 112
;L445:	ld c,e;LCE 212
;L446:	nop;NOP 56
;L447:	sbc a,e;SBE 156
;L448:	halt;HLT 0
;L449:	jp L11464;JMP100 200 44
;L452:	sub a,a;SUA 144
;L453:	ld l,e;LLE 244
;L454:	jfp L8380;JFP88 188 32
;L457:	add a,e;ADE 132
;L458:	ld h,a;LHA 232
;L459:	jp L5296;JMP76 176 20
;L462:	jtpL16604;JTP120 220 64
;L465:	and e;NDE 164
;L466:	inc b;INB 8
;L467:	jpL13520;JMP108 208 52
;L470:	sbc a,a;SBA 152
;L471:	ld (hl),e;LME 252
;L472:	jp c,L10436;JTC96 196 40
;L475:	adc a,e;ACE 140
;L476:	ld l,a;LLA 240
;L477:	jp L7352;JMP84 184 28
;L480:	add a,a;ADA 128
;L481:	ld e,e;LEE 228
;L482:	jp nz,L4268;JFZ72 172 16
;L485:	jp L15576;JMP116 216 60
;L488:	and a;NDA 160
;L489:	add a,104;ADI 4 104
;L491:	ld b,e;LBE 204
;L492:	inc l;INL 48
;L493:	sub a,e;SUE 148
;L494:	ld (hl),a;LMA 248
;L495:	jp L9408;JMP92 192 36
;L498:	adc a,a;ACA 136
;L499:	ld h,e;LHE 236
;L500:	jfs L6324;JFS80 180 24
;L503:	jp L17632;JMP124 224 68
;L506:	xor a;XRA 168
;L507:	adc a,112;ACI 12 112
;L509:	ld c,e;LCE 212
;L510:	nop;NOP 56
;L511:	sbc a,e;SBE 156
;L512:	halt;HLT 0
;L513:	halt;HLT 0
;L514:	halt;HLT 0
;L515:	halt;HLT 1
;L516:	halt;HLT 1
;L517:	halt;HLT 1
;L518:	rlc;RLC 2
;L519:	rlc;RLC 2
;L520:	rfc;RFC 3
;L521:	rfc;RFC 3
;L522:	rfc;RFC 3
;L523:	add a,4;ADI 4 4
;L525:	rst 0;RST000 5
;L526:	rst 0;RST000 5
;L527:	rst 0;RST000 5
;L528:	ld a,6;LAI 6 6
;L530:	ret;RET 7
;L531:	ret;RET 7
;L532:	ret;RET 7
;L533:	inc b;INB 8
;L534:	inc b;INB 8
;L535:	inc b;INB 8
;L536:	dec b;DCB 9
;L537:	dec b;DCB 9
;L538:	rrc;RRC 10
;L539:	rrc;RRC 10
;L540:	rrc;RRC 10
;L541:	ret nz;RFZ 11
;L542:	ret nz;RFZ 11
;L543:	adc a,12;ACI 12 12
;L545:	adc a,13;ACI 12 13
;L547:	rst010;RST010 13
;L548:	ld b,14;LBI 14 14
;L550:	ld b,15;LBI 14 15
;L552:	ret;RET 15
;L553:	inc c;INC 16
;L554:	inc c;INC 16
;L555:	inc c;INC 16
;L556:	dec c;DCC 17
;L557:	dec c;DCC 17
;L558:	dec c;DCC 17
;L559:	rl a;RAL 18
;L560:	rl a;RAL 18
;L561:	rfs;RFS 19
;L562:	rfs;RFS 19
;L563:	rfs;RFS 19
;L564:	sub a,20;SUI 20 20
;L566:	rst020;RST020 21
;L567:	rst020;RST020 21
;L568:	rst020;RST020 21
;L569:	ld c,22;LCI 22 22
;L571:	ret;RET 23
;L572:	ret;RET 23
;L573:	ret;RET 23
;L574:	inc d;IND 24
;L575:	inc d;IND 24
;L576:	dec d;DCD 25
;L577:	dec d;DCD 25
;L578:	dec d;DCD 25
;L579:	rr a;RAR 26
;L580:	rr a;RAR 26
;L581:	rr a;RAR 26
;L582:	rfp;RFP 27
;L583:	rfp;RFP 27
;L584:	sbc a,28;SBI 28 28
;L586:	sbc a,29;SBI 28 29
;L588:	rst030;RST030 29
;L589:	ld d,30;LDI 30 30
;L591:	ld d,31;LDI 30 31
;L593:	ret;RET 31
;L594:	inc e;INE 32
;L595:	inc e;INE 32
;L596:	inc e;INE 32
;L597:	dec e;DCE 33
;L598:	dec e;DCE 33
;L599:	dec e;DCE 33
;L600:	nop;NOP 34
;L601:	nop;NOP 34
;L602:	ret c;RTC 35
;L603:	ret c;RTC 35
;L604:	ret c;RTC 35
;L605:	and a,36;NDI 36 36
;L607:	rst040;RST040 37
;L608:	rst040;RST040 37
;L609:	rst040;RST040 37
;L610:	ld e,38;LEI 38 38
;L612:	ret;RET 39
;L613:	ret;RET 39
;L614:	ret;RET 39
;L615:	inc h;INH 40
;L616:	inc h;INH 40
;L617:	dch;DCH 41
;L618:	dch;DCH 41
;L619:	dch;DCH 41
;L620:	nop;NOP 42
;L621:	nop;NOP 42
;L622:	nop;NOP 42
;L623:	ret z;RTZ 43
;L624:	ret z;RTZ 43
;L625:	 xor 44;XRI 44 44
;L627:	 xor 45;XRI 44 45
;L629:	rst050;RST050 45
;L630:	ld h,46;LHI 46 46
;L632:	ld h,47;LHI 46 47
;L634:	ret;RET 47
;L635:	inc l;INL 48
;L636:	inc l;INL 48
;L637:	inc l;INL 48
;L638:	dec l;DCL 49
;L639:	dec l;DCL 49
;L640:	nop;NOP 50
;L641:	nop;NOP 50
;L642:	nop;NOP 50
;L643:	rts;RTS 51
;L644:	rts;RTS 51
;L645:	rts;RTS 51
;L646:	or 52;ORI 52 52
;L648:	rst060;RST060 53
;L649:	rst060;RST060 53
;L650:	rst060;RST060 53
;L651:	ld l,54;LLI 54 54
;L653:	ret;RET 55
;L654:	ret;RET 55
;L655:	ret;RET 55
;L656:	nop;NOP 56
;L657:	nop;NOP 56
;L658:	nop;NOP 57
;L659:	nop;NOP 57
;L660:	nop;NOP 57
;L661:	nop;NOP 58
;L662:	nop;NOP 58
;L663:	nop;NOP 58
;L664:	rtp;RTP 59
;L665:	rtp;RTP 59
;L666:	cp 60;CPI 60 60
;L668:	cp 61;CPI 60 61
;L670:	rst070;RST070 61
;L671:	ld (hl),62;LMI 62 62
;L673:	ld (hl),63;LMI 62 63
;L675:	ret;RET 63
;L676:	jp nc,L16448;JFC64 64 64
;L679:	inp0;INP000 65
;L680:	inp0;INP000 65
;L681:	call nc,L16962;CFC66 66 66
;L684:	inp1;INP001 67
;L685:	inp1;INP001 67
;L686:	inp1;INP001 67
;L687:	jp L17732;JMP68 68 69
;L690:	inp2;INP002 69
;L691:	inp2;INP002 69
;L692:	call L18246;CAL70 70 71
;L695:	inp3;INP003 71
;L696:	inp3;INP003 71
;L697:	jp nz,L18760;JFZ72 72 73
;L700:	inp4;INP004 73
;L701:	inp4;INP004 73
;L702:	call nz,L19274;CFZ74 74 75
;L705:	inp5;INP005 75
;L706:	inp5;INP005 75
;L707:	jp L19532;JMP76 76 76
;L710:	inp6;INP006 77
;L711:	inp6;INP006 77
;L712:	call L20046;CAL78 78 78
;L715:	inp7;INP007 79
;L716:	inp7;INP007 79
;L717:	jfs L20560;JFS80 80 80
;L720:	out8;OUT010 81
;L721:	out8;OUT010 81
;L722:	cfsL21074;CFS82 82 82
;L725:	out9;OUT011 83
;L726:	out9;OUT011 83
;L727:	out9;OUT011 83
;L728:	jp L21844;JMP84 84 85
;L731:	out10;OUT012 85
;L732:	out10;OUT012 85
;L733:	call L22358;CAL86 86 87
;L736:	out11;OUT013 87
;L737:	out11;OUT013 87
;L738:	jfp L22872;JFP88 88 89
;L741:	out12;OUT014 89
;L742:	out12;OUT014 89
;L743:	cfpL23386;CFP90 90 91
;L746:	out13;OUT015 91
;L747:	out13;OUT015 91
;L748:	jp L23644;JMP92 92 92
;L751:	out14;OUT016 93
;L752:	out14;OUT016 93
;L753:	call L24158;CAL94 94 94
;L756:	out15;OUT017 95
;L757:	out15;OUT017 95
;L758:	jp c,L24672;JTC96 96 96
;L761:	out16;OUT020 97
;L762:	out16;OUT020 97
;L763:	call c,L25186;CTC98 98 98
;L766:	out17;OUT021 99
;L767:	out17;OUT021 99

; Description:  Compute arctan(1/N) using the Gregory expansion of Machin's
;               arctan formula and save in array (ptr_a).
;
;
;                               / 1     1      1       \
;               arctan(1/N) =  |  - - ---- + ---- - ... |
;                              |  N      3      5       |
;                               \     3xN    5xN       /
;
;
; Input:        H/L (hi/lo) pointer to array
;               B = N (8 bit)
;
; Output:       H/L (hi/lo) pointer to array = arctan(1/N)
;
; Registers:    A, B, C, D, E, H, L
;
; Calls:        mset/set_mp, mdiv/div_mp, maddm/add_mp, msubm/sub_mp,
;               mdiv16/div16_mp, mcopy(m)/copy_mp
;
; Globals:      mp_x (16-bit), mp_y (16-bit)
;
; C Algorithm:
;
; void atanbig(bignum A, unsigned short x)
; {
;     bignum X, Y;
;     unsigned short n = 1;
;
;     setbig(X, 1, 0);
;     divbig(X, x);
;     copybig(A, X);
;     x *= x;
;     while (1) {
;         n += 2;
;         divbig(X, x);
;         copybig(Y, X);
;         if (!divbig(Y, n))      // dividend = 0
;             break;
;         if (n & 2)
;             subbig(A, Y);
;         else
;             addbig(A, Y);
;     }
; }

atan_mp:
			; ptr_a to point to arg
;L768:
; backup HL -> DE
	ld d,h;LDH 221
	ld e,l;LEL 230

;	ldhli	ptr_a
;L770:	ld l,13;LLI 54 13
;L772:	ld h,0;LHI 46 0
	ld hl,ptr_a

; store HL(DE) in ptr_a, lo
	ld (hl),e;LME 252
	inc l;INL 48
	ld (hl),d;LMD 251

;	ldhli	regx		; save B
;L777:	ld l,11;LLI 54 11
;L779:	ld h,0;LHI 46 0
	ld hl,regx

	ld (hl),b;LMB 249
	ld a,b;LAB 193
	cp 16;; if A/B < 16 then get square

;	jfc	+
	jp nc,L796;JFC64 28 3


;	ldhli	sqrtbl		; look up square
;L788:	ld l,16;LLI 54 16
;L790:	ld h,0;LHI 46 0
	ld hl,sqrtbl

	ld a,l;LAL 198
	add b;ADB 129
	ld l,a;LLA 240
	ld a,(hl);; load A with square

;/	ldhli	x2		; HL -> x2
L796:
;L796:	ld l,12;LLI 54 12
;L798:	ld h,0;LHI 46 0
	ld hl,x2

	ld (hl),a;; store square

;	ldhli	n		; n = 1 little endian
;L801:	ld l,6;LLI 54 6
;L803:	ld h,0;LHI 46 0
	ld hl,n; n = 1 little endian

	ld (hl),1;LMI 62 1
	inc l;INL 48
	ld (hl),0;LMI 62 0

;	mset	mp_x,1		; x = 1
;mset	macro	a, b		; a = b
;	ldhli	a
;	lbi	b		; load B with initial value
;	cal	set_mp
;	endm

;L810:	ld l,148;LLI 54 148
;L812:	ld h,12;LHI 46 12
	ld hl,mp_x
L814:
	ld b,1;LBI 14 1
	
	call set_mp;L131;CAL70 131 0

;	mdiv	mp_x,regx	; x /= regx
;mdiv	macro	a, b		; a = a / b
;	lddei	a
;	ldbci	b		; load BC ptr to divisor
;	cal	div_mp
;	endm
;L819:	ld e,148;LEI 38 148
;L821:	ld d,12;LDI 30 12
	ld de,mp_x

;L823:	ld c,11;LCI 22 11
;L825:	ld b,0;LBI 14 0
	ld bc,regx
L827:	call div_mp;L1915;CAL70 123 7

;	mcopym	ptr_a,mp_x	; a = x
;mcopym	macro	a, b		; a = b
;	ldbcm	a
;ldbcm	macro	ptr
;	ldhli	ptr		; HL <- PTR
;	lam			; A <- M (L)
;	inl			; HL++ (keep ptr even!)
;	lbm			; B <- M (H)
;	lca			; C <- A
;	endm

;	ldhli	b
;	cal	copy_mp
;	endm
	
;L830:	ld l,13;LLI 54 13
;L832:	ld h,0;LHI 46 0
	ld hl,ptr_a
	ld a,(hl);LAM 199
	inc l;INL 48
	ld b,(hl);LBM 207
	ld c,a;LCA 208

;	ld l,148;LLI 54 148
;	ld h,12;LHI 46 12
	ld hl,mp_x
	call copy_mp;L1073;CAL70 49 4

atan_mp_loop:			; main loop
;L845:	ld l,6;LLI 54 6
;L847:	ld h,0;LHI 46 0
;	ldhli	n		; n = n + 2
	ld hl,n

	ld b,(hl);LBM 207
	inc b;INB 8

;	jfz	+		; n not zero
	jp nz,L859;JFZ72 91 3

	inc l;INL 48
	ld c,(hl);LCM 215
	inc c;INC 16
	ld (hl),c;LMC 250
	dec l;DCL 49

L859:
	inc b;INB 8
	ld (hl),b;LMB 249

;	ldhli	regx		; x = x / regx ^ 2
;L861:	ld l,11;LLI 54 11
;L863:	ld h,0;LHI 46 0
	ld hl,regx

	ld a,(hl);LAM 199

;	cpi	16		; if > 16 /x/x othersize /x2
	cp 16;CPI 60 16
;	jtc	+		; x already x*x, one div required
L868:	jp c,L882;JTC96 114 3

;	mdiv	mp_x,x2		; x >= 16, then do two 
;mdiv	macro	a, b		; a = a / b
;	lddei	a
;	ldbci	b		; load BC ptr to divisor
;	cal	div_mp
;	endm
;L871:	ld e,148;LEI 38 148
;L873:	ld d,12;LDI 30 12
	ld de,mp_x

;L875:	ld c,12;LCI 22 12
;L877:	ld b,0;LBI 14 0
	ld bc,x2
L879:	call div_mp;L1915;CAL70 123 7
L882:
;/	mdiv	mp_x,x2		;   (faster than 16 bit div)
;L882:	ld e,148;LEI 38 148
;L884:	ld d,12;LDI 30 12
	ld de,mp_x

;L886:	ld c,12;LCI 22 12
;L888:	ld b,0;LBI 14 0
	ld bc,x2
L890:	call div_mp;L1915;CAL70 123 7

;	mcopy	mp_y,mp_x	; y = x
;mcopy	macro	a, b		; a = b
;	ldbci	a
;	ldhli	b
;	cal	copy_mp
;	endm

;L893:	ld c,56;LCI 22 56
;L895:	ld b,14;LBI 14 14
	ld bc,mp_y
;L897:	ld l,148;LLI 54 148
;L899:	ld h,12;LHI 46 12
	ld hl,mp_x
L901:	call copy_mp;L1073;CAL70 49 4

;	ldhli	n+1		; if n < 256 then div else div16
;L904:	ld l,7;LLI 54 7
;L906:	ld h,0;LHI 46 0
	ld hl,n+1

	ld a,(hl);LAM 199
	and a;NDA 160

;	jfz	+		; >= 256 use 16 bit div
	jp nz,L928;JFZ72 160 3

;	mdiv	mp_y,n		; < 256 use 8 bit div
;mdiv	macro	a, b		; a = a / b
;	lddei	a
;	ldbci	b		; load BC ptr to divisor
;	cal	div_mp
;	endm
;L913:	ld e,56;LEI 38 56
;L915:	ld d,14;LDI 30 14
	ld de,mp_y
;L917:	ld c,6;LCI 22 6
;L919:	ld b,0;LBI 14 0
	ld bc,n

	call div_mp;L1915;CAL70 123 7
	ret c;RTC 35

;	jmp	++		; still working on it
	jp L940;JMP68 172 3

;/	mdiv16	mp_y,n		; div16
;mdiv16	macro	a, b		; a = a / b
;	lddei	a
;	ldbci	b		; load BC ptr to divisor
;	cal	div16_mp
;	endm

L928:
;	ld e,56;LEI 38 56
;	ld d,14;LDI 30 14
	ld de,mp_y

;L932:	ld c,6;LCI 22 6
;L934:	ld b,0;LBI 14 0
;	jr $
	ld bc,n
	call div16_mp;L1435;CAL70 155 5
	ret c;RTC 35

;/	ldhli	n		; add or sub?
L940:
;L940:	ld l,6;LLI 54 6
;L942:	ld h,0;LHI 46 0
	ld hl,n

	ld a,(hl);LAM 199
	and 2;NDI 36 2

;	jtz	+		; add it
	jp z,L968;JTZ104 200 3

;	msubm	ptr_a,mp_y	; a = a - y
;msubm	macro	a, b		; a = a - b
;	ldhlm	a
;;ldhlm	macro	ptr
;;	ldhli	ptr		; HL <- PTR
;;	lam			; A <- M (L)
;;	inl			; HL++ (keep ptr even!)
;;	lhm			; H <- M (H)
;;	lla			; L <- A
;;	endm
;	ldbci	b
;	cal	sub_mp
;	endm

;L950:	ld l,13;LLI 54 13
;L952:	ld h,0;LHI 46 0
	ld hl,ptr_a
	ld a,(hl);LAM 199
	inc l;INL 48
	ld h,(hl);LHM 239
	ld l,a;LLA 240

;L958:	ld c,56;LCI 22 56
;L960:	ld b,14;LBI 14 14
	ld bc,mp_y
L962:	call sub_mp;L1155;CAL70 131 4
L965:	jp atan_mp_loop;L845;JMP68 77 3

;/	maddm	ptr_a,mp_y	; a = a + y
;maddm	macro	a, b		; a = a + b
;	ldbcm	a
;	ldhli	b
;	cal	add_mp
;	endm

L968:
;	ld l,13;LLI 54 13
;	ld h,0;LHI 46 0
	ld hl,ptr_a
	ld a,(hl);LAM 199
	inc l;INL 48
	ld b,(hl);LBM 207
	ld c,a;LCA 208

;L976:	ld l,56;LLI 54 56
;L978:	ld h,14;LHI 46 14
	ld hl,mp_y

L980:	call add_mp;L1262;CAL70 238 4
L983:	jp atan_mp_loop;L845;JMP68 77 3

;?e:
L986:	ld l,6;LLI 54 6
L988:	ld h,0;LHI 46 0
L990:	xor a;XRA 168
L991:	ld (hl),a;LMA 248
L992:	inc l;INL 48
L993:	ld (hl),a;LMA 248
L994:	ld l,76;LLI 54 76
L996:	ld h,9;LHI 46 9
L998:	ld b,1;LBI 14 1
L1000:	call set_mp;L131;CAL70 131 0
L1003:	ld l,148;LLI 54 148
L1005:	ld h,12;LHI 46 12
L1007:	ld b,1;LBI 14 1
L1009:	call set_mp;L131;CAL70 131 0
L1012:	ld l,7;LLI 54 7
L1014:	ld h,0;LHI 46 0
L1016:	ld c,(hl);LCM 215
L1017:	dec l;DCL 49
L1018:	ld b,(hl);LBM 207
L1019:	inc b;INB 8
L1020:	ld (hl),b;LMB 249
L1021:	jp nz,L1027;JFZ72 3 4
L1024:	inc l;INL 48
L1025:	inc c;INC 16
L1026:	ld (hl),c;LMC 250

L1027:	ld a,c;LAC 194

L1028:	and a;NDA 160
L1029:	jp nz,L1047;JFZ72 23 4
L1032:	ld e,148;LEI 38 148
L1034:	ld d,12;LDI 30 12
L1036:	ld c,6;LCI 22 6
L1038:	ld b,0;LBI 14 0
L1040:	call div_mp;L1915;CAL70 123 7
L1043:	ret c;RTC 35
L1044:	jp L1059;JMP68 35 4

L1047:	ld e,148;LEI 38 148

L1049:	ld d,12;LDI 30 12
L1051:	ld c,6;LCI 22 6
L1053:	ld b,0;LBI 14 0
L1055:	call div16_mp;L1435;CAL70 155 5
L1058:	ret c;RTC 35
L1059:	ld c,76;LCI 22 76
L1061:	ld b,9;LBI 14 9
L1063:	ld l,148;LLI 54 148
L1065:	ld h,12;LHI 46 12
L1067:	call add_mp:;L1262;CAL70 238 4
L1070:	jp L1012;JMP68 244 3

; Description:  Multiprecision transfer:  a = b
; Input:        B/C (hi/lo) address to array (a)
;               H/L (hi/lo) address to array (b)
; Output:       a = b
; Registers:    A, B, C, D, E, H, L
copy_mp:
;	ldi	unrollc		; count down to 0
;L1073:
	ld d,unrollc;105;LDI 30 105

;	jmp	++		; Duff's Device hardcoded for fixed array length
L1075:
	jp L1118;JMP68 94 4

L1078:
	ld a,(hl);LAM 199

;	swhlbce			; HL <> BC
;L1079:	ld e,h;LEH 229
;L1080:	ld h,b;LHB 233
;L1081:	ld b,e;LBE 204
;L1082:	ld e,l;LEL 230
;L1083:	ld l,c;LLC 242
;L1084:	ld c,e;LCE 212
	push bc,hl
	pop bc,hl

	ld (hl),a;LMA 248
	inc l;INL 48

;	swhlbce			; BC <> HL
;L1087:	ld e,h;LEH 229
;L1088:	ld h,b;LHB 233
;L1089:	ld b,e;LBE 204
;L1090:	ld e,l;LEL 230
;L1091:	ld l,c;LLC 242
;L1092:	ld c,e;LCE 212
	push bc,hl
	pop bc,hl

	inc l;INL 48
	ld a,(hl);LAM 199

;	swhlbce			; HL <> BC
;L1095:	ld e,h;LEH 229
;L1096:	ld h,b;LHB 233
;L1097:	ld b,e;LBE 204
;L1098:	ld e,l;LEL 230
;L1099:	ld l,c;LLC 242
;L1100:	ld c,e;LCE 212

	push bc,hl
	pop bc,hl

	ld (hl),a;LMA 248

;	inhl			; HL += 1 (dst)
;L1102:	inc l;INL 48
;L1103:	jp nz,L1107;JFZ72 83 4
;L1106:	inc h;INH 40
;L1107:
	inc hl
;	swhlbce			; BC <> HL
;	ld e,h;LEH 229
;L1108:	ld h,b;LHB 233
;L1109:	ld b,e;LBE 204
;L1110:	ld e,l;LEL 230
;L1111:	ld l,c;LLC 242
;L1112:	ld c,e;LCE 212
	push bc,hl
	pop bc,hl

;	inhl			; HL += 1 (src)
;L1113:	inc l;INL 48
;L1114:	jp nz,L1118;JFZ72 94 4
;L1117:	inc h;INH 40
	inc hl

;/	lam			; A <- M (src)
L1118:
	ld a,(hl);LAM 199

;	swhlbce			; HL <> BC
;L1119:	ld e,h;LEH 229
;L1120:	ld h,b;LHB 233
;L1121:	ld b,e;LBE 204
;L1122:	ld e,l;LEL 230
;L1123:	ld l,c;LLC 242
;L1124:	ld c,e;LCE 212
	push bc,hl
	pop bc,hl

	ld (hl),a;LMA 248
	inc l;INL 48

;	swhlbce			; BC <> HL
;L1127:	ld e,h;LEH 229
;L1128:	ld h,b;LHB 233
;L1129:	ld b,e;LBE 204
;L1130:	ld e,l;LEL 230
;L1131:	ld l,c;LLC 242
;L1132:	ld c,e;LCE 212
	push bc,hl
	pop bc,hl

	inc l;INL 48
	ld a,(hl);LAM 199

;	swhlbce			; HL <> BC
;L1135:	ld e,h;LEH 229
;L1136:	ld h,b;LHB 233
;L1137:	ld b,e;LBE 204
;L1138:	ld e,l;LEL 230
;L1139:	ld l,c;LLC 242
;L1140:	ld c,e;LCE 212
	push bc,hl
	pop bc,hl

	ld (hl),a;LMA 248
	inc l;INL 48

;	swhlbce			; BC <> HL
;L1143:	ld e,h;LEH 229
;L1144:	ld h,b;LHB 233
;L1145:	ld b,e;LBE 204
;L1146:	ld e,l;LEL 230
;L1147:	ld l,c;LLC 242
;L1148:	ld c,e;LCE 212
	push bc,hl
	pop bc,hl

	inc l;INL 48
	dec d;DCD 25
	jp nz,L1078;JFZ72 54 4
	ret;RET 7

; Description:  Multiprecision subtraction:  a = a - b
; Input:        H/L (hi/lo) address to array (a)
;               B/C (hi/lo) address to array (b)
; Output:       a = a - b
; Registers:    A, B, C, D, E, H, L
; Globals:      end_ptr

sub_mp:
;L1155:
				; compute end of array since we have
				;   to go backwards

	ld a,l;LAL 198
	add bin_len&255;ADI 4 lo(bin_len)162
	ld l,a;LLA 240

	ld a,h;LAH 197
;aci	hi(bin_len)	; add with carry ben_len hi and store it
	adc bin_len/256;1;ACI 12 1
	ld h,a;LHA 232

;	lac			; A <- C
;	adi	lo(bin_len)	; add bin_len lo and store it
;	lca			; C <- A
;
;L1163:
	ld a,c;LAC 194
	add bin_len&255;162;ADI 4 162
	ld c,a;LCA 208

;	lab			; A <- B
;	aci	hi(bin_len)	; add with carry ben_len hi and store it
;	lba			; B <- A
	ld a,b;LAB 193
	adc bin_len/256;1;ACI 12 1
	ld b,a;LBA 200

;	ldi	unrollc		; count down to 0
	ld d,unrollc;105;LDI 30 105
	or a;ORA 176

;	jmp	++		; Duff's Device hardcoded for fixed array length
	jp L1223;JMP68 199 4
L1177:
;/	dchl			; HL-- (a)
;	inc l;INL 48
;L1178:	dec l;DCL 49
;L1179:	jp nz,L1183;JFZ72 159 4
;L1182:	dch;DCH 41
;L1183:	dec l;DCL 49
	dec hl

;	lam			; A <- M (a)
	ld a,(hl);LAM 199

;	swhlbce			; HL <> BC
;L1185:	ld e,h;LEH 229
;L1186:	ld h,b;LHB 233
;L1187:	ld b,e;LBE 204
;L1188:	ld e,l;LEL 230
;L1189:	ld l,c;LLC 242
;L1190:	ld c,e;LCE 212
	push hl
	push bc
	pop hl
	pop bc

;	dchl			; HL-- (b)
;L1191:	inc l;INL 48
;L1192:	dec l;DCL 49
;L1193:	jp nz,L1197;JFZ72 173 4
;L1196:	dch;DCH 41
;L1197:	dec l;DCL 49
	dec hl

;	sbm			; A = A - B
	sbc (hl);SBM 159;!a,

;	swhlbce			; BC <> HL
;L1199:	ld e,h;LEH 229
;L1200:	ld h,b;LHB 233
;L1201:	ld b,e;LBE 204
;L1202:	ld e,l;LEL 230
;L1203:	ld l,c;LLC 242
;L1204:	ld c,e;LCE 212
	push hl
	push bc
	pop hl
	pop bc

;	lma			; M = A - B
L1205:	ld (hl),a;LMA 248

;	dcl			; H-- (a)
L1206:	dec l;DCL 49

;	lam			; A <- M (a)
L1207:	ld a,(hl);LAM 199

;	swhlbce			; HL <> BC
;L1208:	ld e,h;LEH 229
;L1209:	ld h,b;LHB 233
;L1210:	ld b,e;LBE 204
;L1211:	ld e,l;LEL 230
;L1212:	ld l,c;LLC 242
;L1213:	ld c,e;LCE 212
	push hl
	push bc
	pop hl
	pop bc

;	dcl			; H-- (b)
	dec l;DCL 49

;	sbm			; A = A - B
	sbc (hl);SBM 159;!a,

;	swhlbce			; BC <> HL
;L1216:	ld e,h;LEH 229
;L1217:	ld h,b;LHB 233
;L1218:	ld b,e;LBE 204
;L1219:	ld e,l;LEL 230
;L1220:	ld l,c;LLC 242
;L1221:	ld c,e;LCE 212
	push hl
	push bc
	pop hl
	pop bc

;	lma			; M = A - B
	ld (hl),a;LMA 248

;/	dcl			; H-- (a)
L1223:	dec l;DCL 49

;	lam			; A <- M (a)
	ld a,(hl);LAM 199

;	swhlbce			; HL <> BC
;L1225:	ld e,h;LEH 229
;L1226:	ld h,b;LHB 233
;L1227:	ld b,e;LBE 204
;L1228:	ld e,l;LEL 230
;L1229:	ld l,c;LLC 242
;L1230:	ld c,e;LCE 212
	push hl
	push bc
	pop hl
	pop bc

;	dcl			; H-- (b)
	dec l;DCL 49

;	sbm			; A = A - B
	sbc (hl);SBM 159;!a,

;swhlbce			; BC <> HL
;L1233:	ld e,h;LEH 229
;L1234:	ld h,b;LHB 233
;L1235:	ld b,e;LBE 204
;L1236:	ld e,l;LEL 230
;L1237:	ld l,c;LLC 242
;L1238:	ld c,e;LCE 212
	push hl
	push bc
	pop hl
	pop bc

;	lma			; M = A - B
	ld (hl),a;LMA 248

;	dcl			; H-- (a)
	dec l;DCL 49

;	lam			; A <- M (a)
	ld a,(hl);LAM 199

;	swhlbce			; HL <> BC
;L1242:	ld e,h;LEH 229
;L1243:	ld h,b;LHB 233
;L1244:	ld b,e;LBE 204
;L1245:	ld e,l;LEL 230
;L1246:	ld l,c;LLC 242
;L1247:	ld c,e;LCE 212
	push hl
	push bc
	pop hl
	pop bc

;	dcl			; H-- (b)
	dec l;DCL 49

;	sbm			; A = A - B
	sbc (hl);SBM 159;!a,

;	swhlbce			; BC <> HL
;L1250:	ld e,h;LEH 229
;L1251:	ld h,b;LHB 233
;L1252:	ld b,e;LBE 204
;L1253:	ld e,l;LEL 230
;L1254:	ld l,c;LLC 242
;L1255:	ld c,e;LCE 212
	push hl
	push bc
	pop hl
	pop bc

;	lma			; M = A - B
	ld (hl),a;LMA 248

;	dcd			; D=D-1	
	dec d;DCD 25

;	jfz	--		; D=0?
	jp nz,L1177;JFZ72 153 4
	ret;RET 7


; Description:  Multiprecision addition:  a = a + b
; Input:        B/C (hi/lo) address to array (a)
;               H/L (hi/lo) address to array (b)
; Output:       a = a + b
; Registers:    A, B, C, D, E, H, L
; Globals:      end_pt

add_mp:
				; compute end of array since we have
				;   to go backwards
;L1262:
	ld a,l;LAL 198
;	adi	lo(bin_len)	; add bin_len lo and store it
	add bin_len&255;162;ADI 4 162
	ld l,a;LLA 240

	ld a,h;LAH 197
;	aci	hi(bin_len)	; add with carry ben_len hi and store it
	adc bin_len/256;1;ACI 12 1
	ld h,a;LHA 232

	ld a,c;LAC 194
;	adi	lo(bin_len)	; add bin_len lo and store it
	add bin_len&255;162;ADI 4 162
	ld c,a;LCA 208

	ld a,b;LAB 193
;	aci	hi(bin_len)	; add with carry ben_len hi and store it
	adc bin_len/256;1;ACI 12 1
	ld b,a;LBA 200

;	ldi	unrollc		; count down to 0
	ld d,unrollc;105;LDI 30 105
	or a;ORA 176

;	jmp	++		; Duff's Device hardcoded for fixed array length
L1281:	jp L1330;JMP68 50 5

L1284:
;/	dchl			; HL-- (b)

;	inc l;INL 48
;	dec l;DCL 49
;	jp nz,L1290;JFZ72 10 5
;	dch;DCH 41
;	dec l;DCL 49
	dec hl

	ld a,(hl);LAM 199

;	swhlbce			; HL <> BC
;L1292:	ld e,h;LEH 229
;L1293:	ld h,b;LHB 233
;L1294:	ld b,e;LBE 204
;L1295:	ld e,l;LEL 230
;L1296:	ld l,c;LLC 242
;L1297:	ld c,e;LCE 212
	push bc,hl
	pop bc,hl

;	dchl			; HL-- (a)
;L1298:	inc l;INL 48
;L1299:	dec l;DCL 49
;L1300:	jp nz,L1304;JFZ72 24 5
;L1303:	dch;DCH 41
;
;L1304:	dec l;DCL 49
	dec hl

	adc (hl);ACM 143;!,a
	ld (hl),a;LMA 248

;	swhlbce			; BC <> HL
;L1307:	ld e,h;LEH 229
;L1308:	ld h,b;LHB 233
;L1309:	ld b,e;LBE 204
;L1310:	ld e,l;LEL 230
;L1311:	ld l,c;LLC 242
;L1312:	ld c,e;LCE 212
	push bc,hl
	pop bc,hl

	dec l;DCL 49
	ld a,(hl);LAM 199

;	swhlbce			; HL <> BC
;L1315:	ld e,h;LEH 229
;L1316:	ld h,b;LHB 233
;L1317:	ld b,e;LBE 204
;L1318:	ld e,l;LEL 230
;L1319:	ld l,c;LLC 242
;L1320:	ld c,e;LCE 212
	push bc,hl
	pop bc,hl

	dec l;DCL 49
	adc (hl);ACM 143;!,a
	ld (hl),a;LMA 248
;	swhlbce			; BC <> HL
;L1324:	ld e,h;LEH 229
;L1325:	ld h,b;LHB 233
;L1326:	ld b,e;LBE 204
;L1327:	ld e,l;LEL 230
;L1328:	ld l,c;LLC 242
;L1329:	ld c,e;LCE 212
	push bc,hl
	pop bc,hl

;/	dcl			; L-- (b)

L1330:
	dec l;DCL 49
	ld a,(hl);LAM 199

;	swhlbce			; HL <> BC
;L1332:	ld e,h;LEH 229
;L1333:	ld h,b;LHB 233
;L1334:	ld b,e;LBE 204
;L1335:	ld e,l;LEL 230
;L1336:	ld l,c;LLC 242
;L1337:	ld c,e;LCE 212
	push bc,hl
	pop bc,hl


	dec l;DCL 49
	adc (hl);ACM 143;,!a
	ld (hl),a;LMA 248

;	swhlbce			; BC <> HL
;L1341:	ld e,h;LEH 229
;L1342:	ld h,b;LHB 233
;L1343:	ld b,e;LBE 204
;L1344:	ld e,l;LEL 230
;L1345:	ld l,c;LLC 242
;L1346:	ld c,e;LCE 212
	push bc,hl
	pop bc,hl

	dec l;DCL 49
	ld a,(hl);LAM 199

;	swhlbce			; HL <> BC
;L1349:	ld e,h;LEH 229
;L1350:	ld h,b;LHB 233
;L1351:	ld b,e;LBE 204
;L1352:	ld e,l;LEL 230
;L1353:	ld l,c;LLC 242
;L1354:	ld c,e;LCE 212
	push bc,hl
	pop bc,hl

	dec l;DCL 49
	adc (hl);ACM 143;!,a
	ld (hl),a;LMA 248

;	swhlbce			; BC <> HL
;L1358:	ld e,h;LEH 229
;L1359:	ld h,b;LHB 233
;L1360:	ld b,e;LBE 204
;L1361:	ld e,l;LEL 230
;L1362:	ld l,c;LLC 242
;L1363:	ld c,e;LCE 212
	push bc,hl
	pop bc,hl

	dec d;DCD 25
	jp nz,L1284;JFZ72 4 5
	ret;RET 7

; Description:  Skip leading zeros (used by div_mp and div16_mp)
; Input:        D/E (hi/lo) address to array (a)
; Output:       None
; Registers:    A, D, E, H, L

skipzeros:
;	ldhli	end_ptr		; HL to point to end_ptr
;L1369:	ld l,4;LLI 54 4
;L1371:	ld h,0;LHI 46 0
	ld hl,end_ptr

	ld a,e;LAE 196

;	adi	lo(bin_end)	; add bin_end lo and store it
	add bin_end&255;161;ADI 4 161
	ld (hl),a;LMA 248
	inc l;INL 48
	ld a,d;LAD 195
;	aci	hi(bin_end)	; add with carry bin_end hi and store it
	adc bin_end/256;1;ACI 12 1
	ld (hl),a;LMA 248


	ld l,e;LLE 244
	ld h,d;LHD 235

;	ldi	bin_len/2	; number of pairs to test
	ld d,bin_len/2;209;LDI 30 209

;	jmp	++		; Duff's Device hardcoded for fixed array length
;L1386:
	jp L1406;JMP68 126 5

L1389:
;/	lam			; A <- M
	ld a,(hl);LAM 199
	and a;NDA 160
	jp nz,L1433;JFZ72 153 5

	inc l;INL 48
	ld a,(hl);LAM 199
	and a;NDA 160

;	jfz	even;Jump if Zero flag clear
	jp nz,L1426;JFZ72 146 5

;L1400:	inc l;INL 48
;L1401:	jp nz,L1405;JFZ72 125 5
;L1404:	inc h;INH 40
	inc hl
	dec d;DCD 25

L1406:
	ld a,(hl);LAM 199
	and a;NDA 160
;	jfz	odd
	jp nz,L1433;JFZ72 153 5
	inc l;INL 48
	ld a,(hl);LAM 199
	and a;NDA 160
	jp nz,L1426;JFZ72 146 5
	inc l;INL 48
	dec d;DCD 25
	jp nz,L1389;JFZ72 109 5
	ld a,1;LAI 6 1
	rr a;RAR 26
	ret;RET 7

;odd:	dchl			; HL--
L1426:
;	inc l;INL 48
;L1427:	dec l;DCL 49
;L1428:	jp nz,L1432;JFZ72 152 5
;L1431:	dch;DCH 41
;L1432:	dec l;DCL 49
	dec hl

;even:	ora			; clear carry
L1433:
	or a;ORA 176

L1434:	ret;RET 7


; Description:  Multiprecision 16-bit division:  a = a / b
; Input:        H/L (hi/lo) address to array (a)
;               B/C (hi/lo) address to divisor (b)
; Output:       a = a / b
; Registers:    A, B, C, D, E, H, L
; Globals:      end_ptr, beg_ptr, cur_ptr, divisor
; Calls:        skipzeros
; C Algorithm:  see div_mp

div16_mp:
;L1435:
	call skipzeros;L1369;; skip leading zeros for speed

	ret c;; return if carry set (all zeros)
				; HL pointing to array MS 16-bit Digit
				; A, D, E disposable
				; BC has pointer to divisor

				; copy (BC) 2 bytes to divisor 2 bytes
				; load divisor into DE from (BC) ptr
;	swhlbc			; swap BC pointer with HL
				; load divisor (BC) in to DE
;L1439:	ld a,h;LAH 197
;L1440:	ld h,b;LHB 233
;L1441:	ld b,a;LBA 200
;L1442:	ld a,l;LAL 198
;L1443:	ld l,c;LLC 242
;L1444:	ld c,a;LCA 208
	push bc,hl
	pop bc,hl

	ld e,(hl);LEM 231
	inc l;INL 48
	ld d,(hl);LDM 223

;	ldhli	divisor		; store DE in divisor (little endian)
;L1448:	ld l,8;LLI 54 8
;L1450:	ld h,0;LHI 46 0
	ld hl,divisor
	ld (hl),e;LME 252
	inc l;INL 48
	ld (hl),d;LMD 251

;	swhlbc			; swap HL pointer with BC
;L1455:	ld a,h;LAH 197
;L1456:	ld h,b;LHB 233
;L1457:	ld b,a;LBA 200
;L1458:	ld a,l;LAL 198
;L1459:	ld l,c;LLC 242
;L1460:	ld c,a;LCA 208
	push bc,hl
	pop bc,hl

;	lbi	0		; set carry/remainder to 0, dividend+0
;	lci	0		; set carry/remainder to 0, dividend+1
	ld b,0;LBI 14 0
	ld c,0;LCI 22 0

;/	sthlm	cur_ptr		; backup array pointer
;sthlm	macro	ptr
;	ldh			; D <- H, backup HL to DE
;	lel			; E <- L
;	ldhli	ptr		; HL <- PTR
;	lme			; M <- E (L)
;	inl			; HL++ (keep ptr even!)
;	lmd			; M <- D (H)
;	lhd			; H <- D, restore HL from DE
;	lle			; L <- E
;	endm

L1465:
	ld d,h;LDH 221
L1466:
	ld e,l;LEL 230
	
;L1467:	ld l,2;LLI 54 2
;L1469:	ld h,0;LHI 46 0
	ld hl,cur_ptr
	ld (hl),e;LME 252
	inc l;INL 48
	ld (hl),d;LMD 251
	ld h,d;LHD 235
	ld l,e;LLE 244

;	ldm			; load MSB from array (dividend+2)
;	inl			
;	lem			; load LSB from array (dividend+3)
	ld d,(hl);LDM 223
	inc l;INL 48
	ld e,(hl);LEM 231

;	ldhlm	divisor		; HL = divisor
;L1479:	ld l,8;LLI 54 8
;L1481:	ld h,0;LHI 46 0
	ld hl,divisor

	ld a,(hl);LAM 199
	inc l;INL 48
	ld h,(hl);LHM 239
	ld l,a;LLA 240
				; HL backuped to cur_ptr
				; BCDE = dividend+0-3, big endian
				; HL = 16-bit divisor


; 32/16 division
 ;rept	16		; do it, 16 times

	ld a,e;LAE 196
	add a,a;ADA 128
	ld e,a;LEA 224
	ld a,d;LAD 195
	rl a;RAL 18
	ld d,a;LDA 216
	ld a,c;LAC 194
	rl a;RAL 18
	ld c,a;LCA 208
	ld a,b;LAB 193
	rl a;RAL 18
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150;!,a
	ld a,b;LAB 193
	sbc h;SBH 157;!,a
	jp c,L1511;JTC96 231 5
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld c,a;LCA 208
	inc e;INE 32
L1511:

	ld a,e;LAE 196
	add a,a;ADA 128
	ld e,a;LEA 224
	ld a,d;LAD 195
	rl a;RAL 18
	ld d,a;LDA 216
	ld a,c;LAC 194
	rl a;RAL 18
	ld c,a;LCA 208
	ld a,b;LAB 193
	rl a;RAL 18
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld a,b;LAB 193
	sbc h;SBH 157
	jp c,L1535;JTC96 255 5
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld c,a;LCA 208
	inc e;INE 32

L1535:
	ld a,e;LAE 196
	add a,a;ADA 128
	ld e,a;LEA 224
	ld a,d;LAD 195
	rl a;RAL 18
	ld d,a;LDA 216
	ld a,c;LAC 194
	rl a;RAL 18
	ld c,a;LCA 208
	ld a,b;LAB 193
	rl a;RAL 18
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld a,b;LAB 193
	sbc h;SBH 157
	jp c,L1559;JTC96 23 6
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld c,a;LCA 208
	inc e;INE 32

L1559:
	ld a,e;LAE 196
	add a,a;ADA 128
	ld e,a;LEA 224
	ld a,d;LAD 195
	rl a;RAL 18
	ld d,a;LDA 216
	ld a,c;LAC 194
	rl a;RAL 18
	ld c,a;LCA 208
	ld a,b;LAB 193
	rl a;RAL 18
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld a,b;LAB 193
	sbc h;SBH 157
	jp c,L1583;JTC96 47 6
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld c,a;LCA 208
	inc e;INE 32

L1583:
	ld a,e;LAE 196
	add a,a;ADA 128
	ld e,a;LEA 224
	ld a,d;LAD 195
	rl a;RAL 18
	ld d,a;LDA 216
	ld a,c;LAC 194
	rl a;RAL 18
	ld c,a;LCA 208
	ld a,b;LAB 193
	rl a;RAL 18
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld a,b;LAB 193
	sbc h;SBH 157
	jp c,L1607;JTC96 71 6
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld c,a;LCA 208
	inc e;INE 32

L1607:
	ld a,e;LAE 196
	add a,a;ADA 128
	ld e,a;LEA 224
	ld a,d;LAD 195
	rl a;RAL 18
	ld d,a;LDA 216
	ld a,c;LAC 194
	rl a;RAL 18
	ld c,a;LCA 208
	ld a,b;LAB 193
	rl a;RAL 18
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld a,b;LAB 193
	sbc h;SBH 157
	jp c,L1631;JTC96 95 6
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld c,a;LCA 208
	inc e;INE 32

L1631:
	ld a,e;LAE 196
	add a,a;ADA 128
	ld e,a;LEA 224
	ld a,d;LAD 195
	rl a;RAL 18
	ld d,a;LDA 216
	ld a,c;LAC 194
	rl a;RAL 18
	ld c,a;LCA 208
	ld a,b;LAB 193
	rl a;RAL 18
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld a,b;LAB 193
	sbc h;SBH 157
	jp c,L1655;JTC96 119 6
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld c,a;LCA 208
	inc e;INE 32

L1655:
	ld a,e;LAE 196
	add a,a;ADA 128
	ld e,a;LEA 224
	ld a,d;LAD 195
	rl a;RAL 18
	ld d,a;LDA 216
	ld a,c;LAC 194
	rl a;RAL 18
	ld c,a;LCA 208
	ld a,b;LAB 193
	rl a;RAL 18
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld a,b;LAB 193
	sbc h;SBH 157
	jp c,L1679;JTC96 143 6
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld c,a;LCA 208
	inc e;INE 32

L1679:
	ld a,e;LAE 196
	add a,a;ADA 128
	ld e,a;LEA 224
	ld a,d;LAD 195
	rl a;RAL 18
	ld d,a;LDA 216
	ld a,c;LAC 194
	rl a;RAL 18
	ld c,a;LCA 208
	ld a,b;LAB 193
	rl a;RAL 18
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld a,b;LAB 193
	sbc h;SBH 157
	jp c,L1703;JTC96 167 6
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld c,a;LCA 208
	inc e;INE 32

L1703:
	ld a,e;LAE 196
	add a,a;ADA 128
	ld e,a;LEA 224
	ld a,d;LAD 195
	rl a;RAL 18
	ld d,a;LDA 216
	ld a,c;LAC 194
	rl a;RAL 18
	ld c,a;LCA 208
	ld a,b;LAB 193
	rl a;RAL 18
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld a,b;LAB 193
	sbc h;SBH 157
	jp c,L1727;JTC96 191 6
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld c,a;LCA 208
	inc e;INE 32

L1727:
	ld a,e;LAE 196
	add a,a;ADA 128
	ld e,a;LEA 224
	ld a,d;LAD 195
	rl a;RAL 18
	ld d,a;LDA 216
	ld a,c;LAC 194
	rl a;RAL 18
	ld c,a;LCA 208
	ld a,b;LAB 193
	rl a;RAL 18
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld a,b;LAB 193
	sbc h;SBH 157
	jp c,L1751;JTC96 215 6
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld c,a;LCA 208
	inc e;INE 32

L1751:
	ld a,e;LAE 196
	add a,a;ADA 128
	ld e,a;LEA 224
	ld a,d;LAD 195
	rl a;RAL 18
	ld d,a;LDA 216
	ld a,c;LAC 194
	rl a;RAL 18
	ld c,a;LCA 208
	ld a,b;LAB 193
	rl a;RAL 18
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld a,b;LAB 193
	sbc h;SBH 157
	jp c,L1775;JTC96 239 6
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld c,a;LCA 208
	inc e;INE 32

L1775:
	ld a,e;LAE 196
	add a,a;ADA 128
	ld e,a;LEA 224
	ld a,d;LAD 195
	rl a;RAL 18
	ld d,a;LDA 216
	ld a,c;LAC 194
	rl a;RAL 18
	ld c,a;LCA 208
	ld a,b;LAB 193
	rl a;RAL 18
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld a,b;LAB 193
	sbc h;SBH 157
	jp c,L1799;JTC96 7 7
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld c,a;LCA 208
	inc e;INE 32

L1799:
	ld a,e;LAE 196
	add a,a;ADA 128
	ld e,a;LEA 224
	ld a,d;LAD 195
	rl a;RAL 18
	ld d,a;LDA 216
	ld a,c;LAC 194
	rl a;RAL 18
	ld c,a;LCA 208
	ld a,b;LAB 193
	rl a;RAL 18
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld a,b;LAB 193
	sbc h;SBH 157
	jp c,L1823;JTC96 31 7
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld c,a;LCA 208
	inc e;INE 32

L1823:
	ld a,e;LAE 196
	add a,a;ADA 128
	ld e,a;LEA 224
	ld a,d;LAD 195
	rl a;RAL 18
	ld d,a;LDA 216
	ld a,c;LAC 194
	rl a;RAL 18
	ld c,a;LCA 208
	ld a,b;LAB 193
	rl a;RAL 18
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld a,b;LAB 193
	sbc h;SBH 157
	jp c,L1847;JTC96 55 7
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld c,a;LCA 208
	inc e;INE 32

L1847:
	ld a,e;LAE 196
	add a,a;ADA 128
	ld e,a;LEA 224
	ld a,d;LAD 195
	rl a;RAL 18
	ld d,a;LDA 216
	ld a,c;LAC 194
	rl a;RAL 18
	ld c,a;LCA 208
	ld a,b;LAB 193
	rl a;RAL 18
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld a,b;LAB 193
	sbc h;SBH 157
	jp c,L1871;JTC96 79 7
	ld b,a;LBA 200
	ld a,c;LAC 194
	sub l;SUL 150
	ld c,a;LCA 208
	inc e;INE 32

L1871:
;	ldhlm	cur_ptr		; restore HL from cur_ptr
;	ld l,2;LLI 54 2
;	ld h,0;LHI 46 0
	ld hl,cur_ptr
	
	ld a,(hl);LAM 199
	inc l;INL 48
	ld h,(hl);LHM 239
	ld l,a;LLA 240

	ld (hl),d;LMD 251
	inc l;INL 48
	ld (hl),e;LME 252

				; check for end do not touch BC, need for chain
;	lddei	end_ptr		; DE <- end_ptr
;lddei	macro	ptr
;	lei	lo(ptr)		; E <- I
;	ldi	hi(ptr)		; D <- I
;	endm
;L1882:	ld e,4;LEI 38 4
;L1884:	ld d,0;LDI 30 0
	ld de,end_ptr

;	swhlde			; HL <-> DE
;L1886:	ld a,h;LAH 197
;L1887:	ld h,d;LHD 235
;L1888:	ld d,a;LDA 216
;L1889:	ld a,l;LAL 198
;L1890:	ld l,e;LLE 244
;L1891:	ld e,a;LEA 224
	ex de,hl

;	lam			; A <- lo(end_ptr)
	ld a,(hl);LAM 199
;	cpe			; A = E?, lo(HL)
	cp e;CPE 188

;	jfz	+		; no match, back to top
	jp nz,L1901;JFZ72 109 7
	inc l;INL 48
	ld a,(hl);LAM 199
	cp d;CPD 187
	ret z;RTZ 43

L1901:
;/	swhlde			; HL <-> DE
;	ld a,h;LAH 197
;L1902:	ld h,d;LHD 235
;L1903:	ld d,a;LDA 216
;L1904:	ld a,l;LAL 198
;L1905:	ld l,e;LLE 244
;L1906:	ld e,a;LEA 224
	ex de,hl

;	inhl			; next digit
;L1907:	inc l;INL 48
;L1908:	jp nz,L1912;JFZ72 120 7
;L1911:	inc h;INH 40
	inc hl
	jp L1465;JMP68 185 5


; Description:  Multiprecision 8-bit division:  a = a / b
;
; Input:        H/L (hi/lo) address to array (a)
;               B/C (hi/lo) address to divisor (b)
;
; Output:       a = a / b
;
; Registers:    A, B, C, D, E, H, L
;
; Globals:      end_ptr, beg_ptr
;
; Calls:        skipzeros, div8(macro)
;
; C Algorithm:
;
; short divbig(number, x)
; bignum number;
; unsigned short x;
; {
;     dword result;
;     short j = 0;
;     unsigned short rest = 0;
;
;     while (number[j] == 0 && j < MAXSIZE)
;         j++;
;     if (j == MAXSIZE)
;         return (0);
;     while (j < MAXSIZE) {
;         result.w.lo = number[j];
;         result.w.hi = rest;
;         number[j] = result.L / x;
;         rest = result.L % x;
;         j++;
;     }
;     return (1);
; }

div_mp:
;L1915:
	call skipzeros;L1369	; skip leading zeros for speed
;	rtc			; return if carry set (all zeros)
;				; set divisor (E) from BC ptr
	ret c;RTC 35

;	swhlbc			; swap HL pointer with BC
;L1919:	ld a,h;LAH 197
;L1920:	ld h,b;LHB 233
;L1921:	ld b,a;LBA 200
;L1922:	ld a,l;LAL 198
;L1923:	ld l,c;LLC 242
;L1924:	ld c,a;LCA 208
	push bc,hl
	pop bc,hl

	ld e,(hl);LEM 231

;	swhlbc			; swap BC pointer with HL
;L1926:	ld a,h;LAH 197
;L1927:	ld h,b;LHB 233
;L1928:	ld b,a;LBA 200
;L1929:	ld a,l;LAL 198
;L1930:	ld l,c;LLC 242
;L1931:	ld c,a;LCA 208
	push bc,hl
	pop bc,hl

;	lci	0		; set carry to 0
;				; we know D*2 is even and bin_len is also even
;				; so unroll twice
L1932:
	ld c,0;LCI 22 0

;/	div8			; div M / E
;div8	macro			; Input:  B = lo, C = hi, E = divisor
;				; Output: B = lo, C = hi
;	lbm			; B <- M, dividend lo
;	rept	8
;	lab			; A <- B
;	ada			; asl (A = A + A)
;	lba			; B <- A, dividend lo
;	lac			; A <- C, dividend hi
;	ral			; rol A (hi)
;	jtc	m0		; 9th bit hi?  Sub it.
;	cpe			; A - E, if A < E set carry
;	jtc	m1		; too small
;m0:	sue			; A = A - E
;	inb			; B++
;m1:	lca			; C <- A
;	endm
;	lmb			; M <- B save it
;	endm
L1934:
	ld b,(hl);LBM 207

	ld a,b;LAB 193
	add a,a;ADA 128
	ld b,a;LBA 200
	ld a,c;LAC 194
	rl a;RAL 18
	jp c,L1947;JTC96 155 7
	cp e;CPE 188
	jp c,L1949;JTC96 157 7
L1947:
	sub e;SUE 148;!,e
	inc b;INB 8
L1949:
	ld c,a;LCA 208
	ld a,b;LAB 193
	add a,a;ADA 128
	ld b,a;LBA 200
	ld a,c;LAC 194
	rl a;RAL 18
	jp c,L1962;JTC96 170 7
	cp e;CPE 188
	jp c,L1964;JTC96 172 7
L1962:
	sub e;SUE 148
	inc b;INB 8
L1964:
	ld c,a;LCA 208

	ld a,b;LAB 193
	add a,a;ADA 128
	ld b,a;LBA 200
	ld a,c;LAC 194
	rl a;RAL 18
	jp c,L1977;JTC96 185 7
	cp e;CPE 188
	jp c,L1979;JTC96 187 7
L1977:
	sub e;SUE 148
	inc b;INB 8
L1979:
	ld c,a;LCA 208

	ld a,b;LAB 193
	add a,a;ADA 128
	ld b,a;LBA 200
	ld a,c;LAC 194
	rl a;RAL 18
	jp c,L1992;JTC96 200 7
	cp e;CPE 188
	jp c,L1994;JTC96 202 7
L1992:
	sub e;SUE 148
	inc b;INB 8
L1994:
	ld c,a;LCA 208
	ld a,b;LAB 193
	add a,a;ADA 128
	ld b,a;LBA 200
	ld a,c;LAC 194
	rl a;RAL 18
	jp c,L2007;JTC96 215 7
	cp e;CPE 188
	jp c,L2009;JTC96 217 7
L2007:
	sub e;SUE 148
	inc b;INB 8
L2009:
	ld c,a;LCA 208
	ld a,b;LAB 193
	add a,a;ADA 128
	ld b,a;LBA 200
	ld a,c;LAC 194
	rl a;RAL 18
	jp c,L2022;JTC96 230 7
	cp e;CPE 188
	jp c,L2024;JTC96 232 7
L2022:
	sub e;SUE 148
	inc b;INB 8
L2024:
	ld c,a;LCA 208
	ld a,b;LAB 193
	add a,a;ADA 128
	ld b,a;LBA 200
	ld a,c;LAC 194
	rl a;RAL 18
	jp c,L2037;JTC96 245 7
	cp e;CPE 188
	jp c,L2039;JTC96 247 7
L2037:
	sub e;SUE 148
	inc b;INB 8
L2039:
	ld c,a;LCA 208
	ld a,b;LAB 193
	add a,a;ADA 128
	ld b,a;LBA 200
	ld a,c;LAC 194
	rl a;RAL 18
	jp c,L2052;JTC96 4 8
	cp e;CPE 188
	jp c,L2054;JTC96 6 8
L2052:
	sub e;SUE 148
	inc b;INB 8
L2054:
	ld c,a;LCA 208

	ld (hl),b;LMB 249

	inc l;INL 48

;	div8			; div M / E
	ld b,(hl);LBM 207

	ld a,b;LAB 193
	add a,a;ADA 128
	ld b,a;LBA 200
	ld a,c;LAC 194
	rl a;RAL 18
	jp c,L2070;JTC96 22 8
	cp e;CPE 188
	jp c,L2072;JTC96 24 8
L2070:
	sub e;SUE 148
	inc b;INB 8
L2072:
	ld c,a;LCA 208
	ld a,b;LAB 193
	add a,a;ADA 128
	ld b,a;LBA 200
	ld a,c;LAC 194
	rl a;RAL 18
	jp c,L2085;JTC96 37 8
	cp e;CPE 188
	jp c,L2087;JTC96 39 8
L2085:
	sub e;SUE 148
	inc b;INB 8
L2087:
	ld c,a;LCA 208
	ld a,b;LAB 193
	add a,a;ADA 128
	ld b,a;LBA 200
	ld a,c;LAC 194
	rl a;RAL 18
	jp c,L2100;JTC96 52 8
	cp e;CPE 188
	jp c,L2102;JTC96 54 8
L2100:
	sub e;SUE 148
	inc b;INB 8
L2102:
	ld c,a;LCA 208
	ld a,b;LAB 193
	add a,a;ADA 128
	ld b,a;LBA 200
	ld a,c;LAC 194
	rl a;RAL 18
	jp c,L2115;JTC96 67 8
	cp e;CPE 188
	jp c,L2117;JTC96 69 8
L2115:
	sub e;SUE 148
	inc b;INB 8
L2117:
	ld c,a;LCA 208
	ld a,b;LAB 193
	add a,a;ADA 128
	ld b,a;LBA 200
	ld a,c;LAC 194
	rl a;RAL 18
	jp c,L2130;JTC96 82 8
	cp e;CPE 188
	jp c,L2132;JTC96 84 8
L2130:
	sub e;SUE 148
	inc b;INB 8
L2132:
	ld c,a;LCA 208
	ld a,b;LAB 193
	add a,a;ADA 128
	ld b,a;LBA 200
	ld a,c;LAC 194
	rl a;RAL 18
	jp c,L2145;JTC96 97 8
	cp e;CPE 188
	jp c,L2147;JTC96 99 8
L2145:
	sub e;SUE 148
	inc b;INB 8
L2147:
	ld c,a;LCA 208
	ld a,b;LAB 193
	add a,a;ADA 128
	ld b,a;LBA 200
	ld a,c;LAC 194
	rl a;RAL 18
	jp c,L2160;JTC96 112 8
	cp e;CPE 188
	jp c,L2162;JTC96 114 8
L2160:
	sub e;SUE 148
	inc b;INB 8
L2162:
	ld c,a;LCA 208
	ld a,b;LAB 193
	add a,a;ADA 128
	ld b,a;LBA 200
	ld a,c;LAC 194
	rl a;RAL 18
	jp c,L2175;JTC96 127 8
	cp e;CPE 188
	jp c,L2177;JTC96 129 8
L2175:
	sub e;SUE 148
	inc b;INB 8
L2177:
	ld c,a;LCA 208

	ld (hl),b;LMB 249

;	inhl			; HL++
;L2179:	inc l;INL 48
;L2180:	jp nz,L2184;JFZ72 136 8
;L2183:	inc h;INH 40
	inc hl
	dec d;DCD 25
	jp nz,L1934;JFZ72 142 7
	or a;ORA 176
	ret;RET 7

; Description:  Print an mp array base 10/100
; Input:        H/L (hi/lo) address to array (a)
; Output:       (a) base 10/100 out to screen
; Registers:    A, B, C, D, E, H, L
; Calls:        bintobcd, prbcd, mult100(macro)
; Globals:      beg_ptr, end_ptr, bcd_cnt, mt100_lo, mt100_hi
print_mp:
;L2190:
; HL now set to MSB
	ld a,(hl);LAM 199
	cp 10;CPI 60 10; is < 10, then use ASCII method

;	jtc	+		;   otherwise, use 2 digit BCD method
	jp c,L2205;JTC96 157 8

L2196:
	call bintobcd	; convert to BCD L99;CAL70 99 0
	call prbcd		; print itcall L84;CAL70 84 0

;	jmp	++		; skip over ASCII method
L2202:	jp L2208;JMP68 160 8

L2205:
;/	adi	030h		; make ASCII
	add 48;ADI 4 48

	push hl
;	out	outport
	rst 10h;out12;OUT014 89
	pop hl
;/	lai	'.'		; print decimal point
L2208:
	ld a,46;LAI 6 46

;	out	outport
	push hl
	rst 10h;out12;OUT014 89
	pop hl
;lmi	0		; zero MSB
;L2211:
	ld (hl),0;LMI 62 0

;	sthlm	beg_ptr		; save HL value to location beg_ptr
;				; compute end of array since we have
;				;   to go backwards
;sthlm	macro	ptr
;	ldh			; D <- H, backup HL to DE
;	lel			; E <- L
;	ldhli	ptr		; HL <- PTR
;	lme			; M <- E (L)
;	inl			; HL++ (keep ptr even!)
;	lmd			; M <- D (H)
;	lhd			; H <- D, restore HL from DE
;	lle			; L <- E
;	endm

	ld d,h;LDH 221
	ld e,l;LEL 230

;L2215:	ld l,2;LLI 54 2
;L2217:	ld h,0;LHI 46 0
	ld hl,beg_ptr

	ld (hl),e;LME 252
	inc l;INL 48
	ld (hl),d;LMD 251
	ld h,d;LHD 235
	ld l,e;LLE 244

;	lbl			; B <- L, store (lo) in B for now
	ld b,l;LBL 206

	ld a,l;LAL 198
;	adi	lo(bin_len)	; add bin_len lo and store it
	add bin_len&255;162;ADI 4 162
	ld l,a;LLA 240
	
	ld a,h;LAH 197
;	aci	hi(bin_len)	; add with carry ben_len hi and store it
	adc bin_len/256;1;ACI 12 1
	ld h,a;LHA 232

;	sthlm	end_ptr		; save HL value to location end_ptr
;				; setup bcd counter for outer loop

	ld d,h;LDH 221
	ld e,l;LEL 230

;	ld l,4;LLI 54 4
;	ld h,0;LHI 46 0
	ld hl,end_ptr

	ld (hl),e;LME 252
	inc l;INL 48
	ld (hl),d;LMD 251
	ld h,d;LHD 235
	ld l,e;LLE 244

;	ldhli	bcd_cnt		; load H/L with bcd_cnt address
;L2244:	ld l,0;LLI 54 0
;L2246:	ld h,0;LHI 46 0
	ld hl,bcd_cnt


;	lmi	lo(bcd_len)	; load bcd_cnt lo
	ld (hl),bcd_len&255;12;LMI 62 12

	inc l;INL 48

;	lmi	hi(bcd_len)	; load bcd_cnt hi
	ld (hl),bcd_len/256;254;LMI 62 254

;	ldb			; D <- B, ok D to store lo(beg_ptr)
	ld d,b;LDB 217
L2254:
print_mp1:			; main loop
				; multi array x 100
				; loop from LSB to MSB
				; 16-bit product = array[i] * 100 + carry_mp;
				; array[i] = product lo
				; carry_mp = product hi
				;
				; C Algorithm:
				;
				; while (j >= 0) {
				;    result.L = (long) number[j] * 100 + carry;
				;    number[j] = result.w.lo;
				;    carry = result.w.hi;
				;    j--;
				; }

;	ldhlm	end_ptr		; load HL value from location end_ptr
				; backwards loop (LSB to MSB)
;	ld l,4;LLI 54 4
;	ld h,0;LHI 46 0
	ld hl,end_ptr
	ld a,(hl);LAM 199
	inc l;INL 48
	ld h,(hl);LHM 239
	ld l,a;LLA 240


	ld e,0;LEI 38 0
;	lei	0		; E = carry = 0
				; E is the carry from mult100 to mult100
				; A,B,C,E (carry) used for mult100
				; D and E must not be touched!

;	ldi	unrollc		; count down to 0
	ld d,unrollc;105;LDI 30 105

;	jmp	++		; mp_array * 100 loop
L2266:	jp L2311;JMP68 7 9

L2269:
;/	dchl			; HL--
;L2269:	inc l;INL 48
;L2270:	dec l;DCL 49
;L2271:	jp nz,L2275;JFZ72 227 8
;L2274:	dch;DCH 41
;L2275:	dec l;DCL 49
	dec hl

;	mult100			; M = lo(M*100), E = hi(M*100)
;mult100	macro
;	lam			; get A (page aligned table offset)
;	lbh			; BC = HL
;	lcl
;	lhi	hi(mt100_lo)	; H to point to low table
;	lla			; L = A (position of A*100)
;	lam			; A <- (HL), LSB A = A*100
;	ade			; LSB A = A + E, add mp carry
;	inh			; H++ to get MSB
;	lem			; E <- (HL), MSB E = A*100
;	jfc	m0		; if carry set from add, then
;	ine			;   E++
;m0:
;	lhb			; HL = BC
;	llc
;	lma			; M <- A, store LSB
;	endm
	ld a,(hl);LAM 199
	ld b,h;LBH 205
	ld c,l;LCL 214

;lhi	hi(mt100_lo)	; H to point to low table
	ld h,mt100_lo/256;1;LHI 46 1
	ld l,a;LLA 240
	ld a,(hl);LAM 199
	add e;ADE 132
	inc h;INH 40
	ld e,(hl);LEM 231
	jp nc,L2290;JFC64 242 8
	inc e;INE 32
L2290:
	ld h,b;LHB 233
	ld l,c;LLC 242
	ld (hl),a;LMA 248

;	dcl			; L--
	dec l;DCL 49

;	mult100			; M = lo(M*100), E = hi(M*100)
	ld a,(hl);LAM 199
	ld b,h;LBH 205
	ld c,l;LCL 214

	ld h,mt100_lo/256;1;LHI 46 1
	ld l,a;LLA 240
	ld a,(hl);LAM 199
	add e;ADE 132
	inc h;INH 40
	ld e,(hl);LEM 231
	jp nc,L2308;JFC64 4 9
	inc e;INE 32
L2308:
	ld h,b;LHB 233
	ld l,c;LLC 242
	ld (hl),a;LMA 248

;/	dcl			; L--
L2311:
	dec l;DCL 49

	ld a,(hl);LAM 199
	ld b,h;LBH 205
	ld c,l;LCL 214

	ld h,mt100_lo/256;1;LHI 46 1
	ld l,a;LLA 240
	ld a,(hl);LAM 199
	add e;ADE 132
	inc h;INH 40
	ld e,(hl);LEM 231
	jp nc,L2326;JFC64 22 9
	inc e;INE 32
L2326:
	ld h,b;LHB 233
	ld l,c;LLC 242
	ld (hl),a;LMA 248

	dec l;DCL 49

	ld a,(hl);LAM 199
	ld b,h;LBH 205
	ld c,l;LCL 214
	ld h,mt100_lo/256;1;LHI 46 1
	ld l,a;LLA 240
	ld a,(hl);LAM 199
	add e;ADE 132
	inc h;INH 40
	ld e,(hl);LEM 231
	jp nc,L2344;JFC64 40 9
	inc e;INE 32
L2344:
	ld h,b;LHB 233
	ld l,c;LLC 242
	ld (hl),a;LMA 248
	dec d;DCD 25

;	jfz	--		; D=0?
	jp nz,L2269;JFZ72 221 8

			; HL now set to MSB
	ld a,(hl);LAM 199
	call bintobcd	; convert to BCDL99;CAL70 99 0
	call prbcd		; print base 100 digitL84;CAL70 84 0

;	lmi	0		; zero MSB
	; check for all decimal digits printed

	ld (hl),0;LMI 62 0

;	ldhli	bcd_cnt		; load H/L with bcd_cnt address
;				;   works with bcd_len = 65536-(dec_len/2)
;				;   counting up is easier
;
;L2360:	ld l,0;LLI 54 0
;L2362:	ld h,0;LHI 46 0
	ld hl,bcd_cnt
	
	ld b,(hl);LBM 207
	inc b;INB 8
	ld (hl),b;LMB 249
;	jfz	print_mp1	; if not zero keep going, otherwise
	jp nz,L2254;JFZ72 206 8

	inc l;INL 48
	ld b,(hl);LBM 207
	inc b;INB 8
	ret z;RTZ 43
	ld (hl),b;LMB 249
	jp L2254;JMP68 206 8

	org $7000
mt100_lo:
	db	000h,064h,0C8h,02Ch,090h,0F4h,058h,0BCh,020h,084h,0E8h,04Ch,0B0h,014h,078h,0DCh
	db	040h,0A4h,008h,06Ch,0D0h,034h,098h,0FCh,060h,0C4h,028h,08Ch,0F0h,054h,0B8h,01Ch
	db	080h,0E4h,048h,0ACh,010h,074h,0D8h,03Ch,0A0h,004h,068h,0CCh,030h,094h,0F8h,05Ch
	db	0C0h,024h,088h,0ECh,050h,0B4h,018h,07Ch,0E0h,044h,0A8h,00Ch,070h,0D4h,038h,09Ch
	db	000h,064h,0C8h,02Ch,090h,0F4h,058h,0BCh,020h,084h,0E8h,04Ch,0B0h,014h,078h,0DCh
	db	040h,0A4h,008h,06Ch,0D0h,034h,098h,0FCh,060h,0C4h,028h,08Ch,0F0h,054h,0B8h,01Ch
	db	080h,0E4h,048h,0ACh,010h,074h,0D8h,03Ch,0A0h,004h,068h,0CCh,030h,094h,0F8h,05Ch
	db	0C0h,024h,088h,0ECh,050h,0B4h,018h,07Ch,0E0h,044h,0A8h,00Ch,070h,0D4h,038h,09Ch
	db	000h,064h,0C8h,02Ch,090h,0F4h,058h,0BCh,020h,084h,0E8h,04Ch,0B0h,014h,078h,0DCh
	db	040h,0A4h,008h,06Ch,0D0h,034h,098h,0FCh,060h,0C4h,028h,08Ch,0F0h,054h,0B8h,01Ch
	db	080h,0E4h,048h,0ACh,010h,074h,0D8h,03Ch,0A0h,004h,068h,0CCh,030h,094h,0F8h,05Ch
	db	0C0h,024h,088h,0ECh,050h,0B4h,018h,07Ch,0E0h,044h,0A8h,00Ch,070h,0D4h,038h,09Ch
	db	000h,064h,0C8h,02Ch,090h,0F4h,058h,0BCh,020h,084h,0E8h,04Ch,0B0h,014h,078h,0DCh
	db	040h,0A4h,008h,06Ch,0D0h,034h,098h,0FCh,060h,0C4h,028h,08Ch,0F0h,054h,0B8h,01Ch
	db	080h,0E4h,048h,0ACh,010h,074h,0D8h,03Ch,0A0h,004h,068h,0CCh,030h,094h,0F8h,05Ch
	db	0C0h,024h,088h,0ECh,050h,0B4h,018h,07Ch,0E0h,044h,0A8h,00Ch,070h,0D4h,038h,09Ch

mt100_hi:
	db	000h,000h,000h,001h,001h,001h,002h,002h,003h,003h,003h,004h,004h,005h,005h,005h
	db	006h,006h,007h,007h,007h,008h,008h,008h,009h,009h,00Ah,00Ah,00Ah,00Bh,00Bh,00Ch
	db	00Ch,00Ch,00Dh,00Dh,00Eh,00Eh,00Eh,00Fh,00Fh,010h,010h,010h,011h,011h,011h,012h
	db	012h,013h,013h,013h,014h,014h,015h,015h,015h,016h,016h,017h,017h,017h,018h,018h
	db	019h,019h,019h,01Ah,01Ah,01Ah,01Bh,01Bh,01Ch,01Ch,01Ch,01Dh,01Dh,01Eh,01Eh,01Eh
	db	01Fh,01Fh,020h,020h,020h,021h,021h,021h,022h,022h,023h,023h,023h,024h,024h,025h
	db	025h,025h,026h,026h,027h,027h,027h,028h,028h,029h,029h,029h,02Ah,02Ah,02Ah,02Bh
	db	02Bh,02Ch,02Ch,02Ch,02Dh,02Dh,02Eh,02Eh,02Eh,02Fh,02Fh,030h,030h,030h,031h,031h
	db	032h,032h,032h,033h,033h,033h,034h,034h,035h,035h,035h,036h,036h,037h,037h,037h
	db	038h,038h,039h,039h,039h,03Ah,03Ah,03Ah,03Bh,03Bh,03Ch,03Ch,03Ch,03Dh,03Dh,03Eh
	db	03Eh,03Eh,03Fh,03Fh,040h,040h,040h,041h,041h,042h,042h,042h,043h,043h,043h,044h
	db	044h,045h,045h,045h,046h,046h,047h,047h,047h,048h,048h,049h,049h,049h,04Ah,04Ah
	db	04Bh,04Bh,04Bh,04Ch,04Ch,04Ch,04Dh,04Dh,04Eh,04Eh,04Eh,04Fh,04Fh,050h,050h,050h
	db	051h,051h,052h,052h,052h,053h,053h,053h,054h,054h,055h,055h,055h,056h,056h,057h
	db	057h,057h,058h,058h,059h,059h,059h,05Ah,05Ah,05Bh,05Bh,05Bh,05Ch,05Ch,05Ch,05Dh
	db	05Dh,05Eh,05Eh,05Eh,05Fh,05Fh,060h,060h,060h,061h,061h,062h,062h,062h,063h,063h

end
	display /d,end-begin
	display L1847
	
	savesna "!void.sna",runi;begin

